searchNodes=[{"doc":"Sise is a library that implements the simple service discovery protocol (SSDP).Sise will listen on the network for announcements of available UPnP devices and services. Additionally it will send out search requests from time to time. All discovered devices will be stored by Sise.A client of this library can either fetch the discoveries or subscribe for notifications (on subscription the listener will be called with the already discovered devices/services).Sise implements the Application behaviour and thus will start itself with detecting devices and service.","ref":"Sise.html","title":"Sise","type":"module"},{"doc":"Get discovered device and service informationCall this function to get information about discovered devices and services.","ref":"Sise.html#get/1","title":"Sise.get/1","type":"function"},{"doc":"Subscribe to receive notifications about discoveriesWhen calling this function, the caller willreceive a notification message of type :ssdp_add for every already known discoveryreceive a message for every change in the futureIt is possible to subscribe to multiple different notification types.The possible notification messages to be received are these:{:ssdp_add, Sise.Discovery.t()}This message informs that a new device or service has been discovered. It will contain a struct with all available information on the discovery.{:ssdp_update, Sise.Discovery.t(), [{atom(), String.t(), String.t()}]}Informs the listener that the available information about a known device/service has changed. The message will carry the new version of the Discovery struct. It will also carry a list with the differences between the old and the new device/service information.{:ssdp_delete, Sise.Discovery.t()}Informs that a device/service is no longer available. The message will carry the last known version of the Discovery struct. See also Sise.Discovery.diff/2.","ref":"Sise.html#subscribe/1","title":"Sise.subscribe/1","type":"function"},{"doc":"Unsubscribe from notifications about discoveries.Note that the notification mechanism does a very simple matching for notification types. If you subscribe to multiple concrete services/devices and then unsubscribe(:all), they will all be removed. However if you subscribe to :all services/devices and then unsubscribe from a concrete one you will still get all notifications.","ref":"Sise.html#unsubscribe/1","title":"Sise.unsubscribe/1","type":"function"},{"doc":"SSDP's &quot;notification type&quot; (aka device or service others might need)This type is used as a parameter to select the 'notification type' the caller is interested in.If atom :all is given the client will get all of the discoveries. Whereas if a string is given it is interpreted as the exact notification type as given by the peer.Examples for UPnP notification types are &quot;upnp:rootdevice&quot; or &quot;urn:schemas-upnp-org:service:SwitchPower:1&quot;.","ref":"Sise.html#t:nt/0","title":"Sise.nt/0","type":"type"},{"doc":"A struct for describing found devices or services together with some useful functions","ref":"Sise.Discovery.html","title":"Sise.Discovery","type":"module"},{"doc":"Computes a diff between two Discovery structsGiven two Discovery structs this method will compute a diff. The returned list will contain 3-tuples wherethe first entry is the Discovery's key whose values differ in both structsthe second entry is the value of left andthe third entry is the value of rightIf the returned list is empty it means that the two given structs are equal.","ref":"Sise.Discovery.html#diff/2","title":"Sise.Discovery.diff/2","type":"function"},{"doc":"Is the discovered device or service running on localhost?This function inspects the location: header of the discovery. If this header indicates that the found device or service is running on localhost then this function will return true (otherwise false)","ref":"Sise.Discovery.html#localhost?/1","title":"Sise.Discovery.localhost?/1","type":"function"},{"doc":"Merge two discovery packets; uses on_top's values if available and base as defaultOne packet provides the &quot;base values&quot; the other one provides &quot;updates&quot; on top of the base. If for any key there's no &quot;updated&quot; value then the base value is used.","ref":"Sise.Discovery.html#merge/2","title":"Sise.Discovery.merge/2","type":"function"},{"doc":"Describes a discovered device or serviceThis struct contains the HTTP header values from either an SSDP notify message or an MSearch-response. So this describes a device or service announced by &quot;someone else&quot;.The fields (accorings to &quot;UPnP Device Architecture v2.0) have the following meaning:boot_id: represents the boot instance of the device expressed according to a monotonically increasing value. Its field value shall be a non-negative integer that shall be increased on each initial announce of the UPnP device.Control points can use this header field to detect the case when a device leaves and rejoins the network (&quot;reboots&quot; in UPnP terms). It can be used by control points for a number of purposes such as re-establishing desired event subscriptions, checking for changes to the device state that were not evented since the device was off-line.config_id: contains a non-negative integer value which represents &quot;the configuration&quot; of a UPnP device. The configuration of a root device consists of the following information: the DDD of the root device and all its embedded devices, and the SCPDs of all the contained services. If any part of the configuration changes, the config_id: field value shall be changed. So control points can use this value to decide if any downloaded and cache information about the device is still valid or not.location: contains a URL to the UPnP description of the root device. Normally the host portion contains a literal IP address rather than a domain name in unmanaged networks. Specified by UPnP vendor. Single absolute URL (see RFC 3986).next_boot_id: is contained if the device sends an update. The device will then send the old boot_id: so a control point can recognize it plus this next_boot_id: which will then (and for all subsequent announcements) be the valid boot_id:.nt: contains the notification type. Please consult the spec for detailed informationsecure_location: provides a base URL with &quot;https:&quot; for the scheme component and indicate the correct &quot;port&quot; subcomponent in the &quot;authority&quot; component for a TLS connection. Because the scheme and authority components are not included in relative URLs, these components are obtained from the base URL provided by either location: or secure_location:.server: vendor provided description of the UPnP software running on the deviceusn: contains &quot;Unique Service Name&quot;. Identifies a unique instance of a device or service. Please consult th spec for detailed information.","ref":"Sise.Discovery.html#t:t/0","title":"Sise.Discovery.t/0","type":"type"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright [yyyy] [name of copyright owner] Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"ChangelogAll notable changes to this project will be documented in this file.The format is based on Keep a Changelog, and this project adheres to Semantic Versioning.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"AddedAdded doc strings to the config moduleFixedFixed a crash when initially notifying newly subscribed listeners","ref":"changelog.html#0-9-2-2021-04-19","title":"Changelog - [0.9.2] - 2021-04-19","type":"extras"},{"doc":"AddedExtended Readme; tiny doc fixes","ref":"changelog.html#0-9-1-2021-04-12","title":"Changelog - [0.9.1] - 2021-04-12","type":"extras"},{"doc":"AddedFirst release of the SSDP library &quot;Sise&quot;Implements Application behaviour; thus will automatically start searching for devices and servicesWill send out M-Search probes every 20 minutes (interval is configurable)Will listen for UDP multicast (Notify-)messagesWill store found information about devices and services in a way compliant to &quot;UPnP Device Architecture 2.0&quot;Clients can fetch information about known devices/services; either all or for a specific notification typeClients can subscribe for notifications about new, updated or deleted devices/services; either all or for a specific notification typeClients can unsubscribeDocumented the API with ExDocPublished to hex.pm","ref":"changelog.html#0-9-0-2021-04-04","title":"Changelog - [0.9.0] - 2021-04-04","type":"extras"}]